unit ggt1_u;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, io, math, Gauges;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    GroupBox1: TGroupBox;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    RadioButton3: TRadioButton;
    procedure Button1Click(Sender: TObject);
    procedure Edit1Change(Sender: TObject);
    procedure Edit2Change(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private-Deklarationen}
  public
    { Public-Deklarationen}
  end;

var
  Form1: TForm1;
  n1,n2,gt : longint;

implementation

{$R *.DFM}

function ggt(z1,z2 : longint) : longint;
var teiler,m : longint;
begin
m := min(z1,z2);
result := 1;
for teiler := 2 to m do
if z1 mod teiler = 0 then
  if z2 mod teiler = 0 then result := teiler;
end;

function ggtEuklid(z1,z2 : longint) : longint;
var a,b,rest : longint;
begin
a := max(z1,z2); b := min(z1,z2);
while b > 0 do begin
  rest := a mod b;
  a := b; b := rest;
end;
result := a;
end;


function ggtRekursiv(z1,z2:longint):longint;
var a,b,rest:longint;
begin
a := max(z1,z2); b := min(z1,z2);
if a > b then  ggtRekursiv := ggtRekursiv(a-b,b) else ggtRekursiv := b;
end;



procedure TForm1.Button1Click(Sender: TObject);
begin
Edit3.Text := '';
if RadioButton1.Checked then Edit3.Text := IntToStr(ggt(n1,n2));
if RadioButton2.Checked then Edit3.Text := IntToStr(ggtEuklid(n1,n2));
if RadioButton3.Checked then Edit3.Text := IntToStr(ggtRekursiv(n1,n2));
end;

procedure TForm1.Edit1Change(Sender: TObject);
var code : integer;
begin
val(Edit1.Text,n1,code);
if code <> 0 then  MessageDlg('Falsche Eingabe', mtError, [mbok],0);
end;

procedure TForm1.Edit2Change(Sender: TObject);
var code : integer;
begin
val(Edit2.Text,n2,code);
if code <> 0 then  MessageDlg('Falsche Eingabe', mtError, [mbok],0);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
RadioButton1.Checked := true;
end;

end.
